using System;
using System.Configuration;

namespace IFXplus.SmartStorage.Settings
{
    public class MemoryStorageProviderSettings : BaseStorageProviderSettings
    {
        
        #region StorageProviderType
    
        public override StorageProviderType Type
        {
            get { return StorageProviderType.Memory; }
        }

        #endregion

        [ConfigurationProperty("capacity", DefaultValue = "10000", IsKey = false, IsRequired = true)]
        public int Capacity
        {
            get { return (int)base["capacity"]; }
            set { base["capacity"] = value; }
        }

        [ConfigurationProperty("scavengingInterval", DefaultValue = "0.00:05:00.000", IsKey = false, IsRequired = true)]
        public TimeSpan ScavengingInterval
        {
            get { return (TimeSpan)base["scavengingInterval"]; }
            set { base["scavengingInterval"] = value; }
        }

    }
}
