using System;

namespace IFXplus.SmartStorage.Providers
{
    /// <summary>
    /// StorageProviderReference
    /// </summary>
    [Serializable]
    public class StorageProviderReference
    {
        #region Fields
        
        private string _Id;
        private StorageProviderType _Type;
        
        #endregion

        #region Constructor
		
        /// <summary>
        /// Crea una nuova istanza di StorageProviderReference
        /// </summary>
        /// <remarks>Non utilizzare il costruttore vuoto per istanziare una nuova istanza di StorageProviderReference (ha visibilit "public" solo per consentire la serializzazione)</remarks>                
        public StorageProviderReference() {}

        /// <summary>
        /// Crea una nuova istanza di StorageProviderReference
        /// </summary>
        /// <param name="id">Id</param>
        /// <param name="type">Type</param>
        public StorageProviderReference(string id, StorageProviderType type)
        {
            Id = id;
            Type = type;
        }

        #endregion

        #region Properties

        /// <summary>
        /// Id
        /// </summary>
        public string Id
        {
            get { return _Id; }
            set { _Id = value; }
        }
        
        /// <summary>
        /// Type
        /// </summary>
        public StorageProviderType Type
        {
            get { return _Type; }
            set { _Type = value; }
        }
        
        #endregion

        #region Methods

        public override string ToString()
        {
            return string.Format("{{ \"Type\" : {0}, \"Id\" : \"{1}\" }}", Type, Id);
        }

        #endregion
        
    }
}
